# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: __init__.py 756 2005-06-28 22:47:15Z sidnei $
"""

import os
import sys

# this code is temporarily here. It will be moved to SQLObject later.
import sqlobject

class SODateCol(sqlobject.col.SOCol):

    def _mysqlType(self):
        return 'DATE'

    def _postgresType(self):
        return 'DATE'

class DateCol(sqlobject.col.Col):

    baseClass = SODateCol

sqlobject.col.DateCol = DateCol

def package_home(gdict):
    filename = gdict["__file__"]
    return os.path.dirname(filename)

class File:

    _v_last_read = 0
    _v_text = None

    def __init__(self, filename, _prefix=None):
        path = self.get_path_from_prefix(_prefix)
        self.filename = os.path.join(path, filename)
        if not os.path.isfile(self.filename):
            raise ValueError("No such file", self.filename)

    def get_path_from_prefix(self, _prefix):
        if isinstance(_prefix, str):
            path = _prefix
        else:
            if _prefix is None:
                _prefix = sys._getframe(2).f_globals
            path = package_home(_prefix)
        return path

    def _cook_check(self):
        if self._v_last_read and not __debug__:
            return
        __traceback_info__ = self.filename
        try:
            mtime = os.path.getmtime(self.filename)
        except OSError:
            mtime = 0
        if mtime == self._v_last_read:
            return
        f = open(self.filename, "rb")
        try:
            text = f.read()
        except:
            f.close()
            raise
        f.close()
        self._v_text = text
        self._v_last_read = mtime

    def __str__(self):
        self._cook_check()
        return self._v_text

from project import Project
from sample import Sample, AdditionalSampleData
from subjecttype import SubjectType
from sampletype import SampleType
from container import Container
from container_location import ContainerLocation
from containertype import ContainerType
from location import Location
from location_project import LocationProject
from aliquot import Aliquot
from technician import Technician
from technician_project import TechnicianProject
from principal import Principal
from units import ConcentrationUnit, VolumeUnit, WeightUnit
from security.principal import SecurityPrincipal
from security.role import SecurityRole
from schema.fields import SchemaField
from sampletypeschema import SampleTypeSchema
from sampletype_project import SampleTypeProject

__all__ = ('Project', 'Principal',
           'Technician', 'TechnicianProject',
           'Location', 'LocationProject', 'SubjectType',
           'SampleType', 'SampleTypeProject', 'Sample',
           'ContainerType', 'Container', 'ContainerLocation',
           'ConcentrationUnit', 'VolumeUnit', 'WeightUnit',
           'Aliquot', 'SecurityPrincipal', 'SecurityRole',
           'SampleTypeSchema', 'SchemaField',
           'AdditionalSampleData')
