# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: absoluteurl.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.app import zapi
from zope.app.traversing.browser.absoluteurl import AbsoluteURL as AbsURL, \
     _insufficientContext
from zope.proxy import sameProxiedObjects
from sip.interfaces import INoopBreadcrumb, IAppRoot, INolinkBreadcrumb
from sip.interfaces.container import IContainer

class AbsoluteURL(AbsURL):

    def breadcrumbs(self):

        context = self.context
        request = self.request

        # We do this here do maintain the rule that we must be wrapped
        container = getattr(context, '__parent__', None)
        if container is None:
            raise TypeError, _insufficientContext

        if sameProxiedObjects(context, request.getVirtualHostRoot()) or \
               isinstance(context, Exception):
            if IAppRoot.providedBy(context):
                return ({'name':context.__name__,
                        'title':'Project Listing',
                        'url': self.request.getApplicationURL()}, )
            return ({'name':'', 'url': self.request.getApplicationURL()}, )

        base = tuple(zapi.getView(container,
                                  'absolute_url', request).breadcrumbs())

        name = getattr(context, '__name__', None)
        if name is None:
            raise TypeError, _insufficientContext

        if (INoopBreadcrumb.providedBy(context) or
            (IContainer.providedBy(context)
             and context.parent_id == 0)):
            base += ({'name': '',
                      'title': '',
                      'url': ("%s/%s" % (base[-1]['url'], name))
                      }, )
        elif name:
            if IAppRoot.providedBy(context):
                title = 'Project Listing'
            else:
                title = getattr(context, 'name', name)
            if title in ('+', 'schema'):
                title = name = ''
            if INolinkBreadcrumb.providedBy(context):
                url = ''
            else:
                url = "%s/%s" % (base[-1]['url'], name)
            base += ({'name': name,
                      'title': title,
                      'url': url
                      }, )
        return base
