# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: edit.py 749 2005-06-28 22:21:49Z sidnei $
"""
from zope.app.form.browser.editview import EditView as BaseEditView
from zope.app.form.browser.submit import Update

from sqlos.event.interfaces import expired
from sip.browser import api

class EditView(BaseEditView):

    def __init__(self, *args, **kw):
        super(EditView, self).__init__(*args, **kw)
        project = api.queryProject(self.context)
        if project is not None and not project.require_commit_message:
            filter_out = ['commit_message']
            f = lambda x: x not in filter_out
            self.fieldNames = filter(f, self.fieldNames)

    def update(self):
        request = self.request
        if Update in request and not request.form.get('field.commit_message'):
            project = api.queryProject(self.context)
            if project is not None and not project.require_commit_message:
                msg = u"Modified by '%s'" % request.principal.id
                request.form['field.commit_message'] = msg
        status = super(EditView, self).update()
        if self.errors:
            expired(self.adapted)
        return status
