# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: project_list.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.app import zapi
from sip.browser import api
from zope.app.publisher.browser import BrowserView
from zope.app.pagetemplate.viewpagetemplatefile import ViewPageTemplateFile
from zope.app.container.interfaces import IReadContainer

class ProjectListing(BrowserView):
    """ Project Listing view for SIP App Root """

    def canAdminApp(self):
        return api.checkSIPPermission(self.context, 'sip.ManageApplication')

    def listContentInfo(self):
        request = self.request
        info = {}
        if 'projects' in self.context.keys():
            context = zapi.traverse(self.context, 'projects')
            info = map(self._extractContentInfo,
            IReadContainer(context).items())
        return info


    def _extractContentInfo(self, item):
        request = self.request

        id, obj = item
        info = {}
        info['id'] = info['cb_id'] = id
        info['object'] = obj
        info['has_stypes'] = len(zapi.traverse(obj, 'sampletypes'))
        info['has_locs'] = len(obj.valid_locations)

        info['url'] = "projects/%s" % id

        try:
            info['title'] = obj.name
        except:
            info['title'] = '<no title>'

        isAdmin = self.canAdminApp()

        info['can_admin'] = isAdmin or api.checkSIPPermission(obj,
                                                           'sip.ManageProject')
        info['can_report'] = isAdmin or api.checkSIPPermission(obj,
                                                             'sip.ViewProject')
        info['can_add'] = isAdmin or api.checkSIPPermission(obj,
                                                               'sip.AddSample')

        return info

    index = ViewPageTemplateFile('project_list.pt')
