# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: tree_views.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.app.tree.browser.cookie import CookieTreeView
from zope.app.tree.filters import OnlyInterfacesFilter
from zope.app.publisher.browser import BrowserView

from sip.shipment.interfaces import IShipment, IOutgoingShipmentState
from sip.interfaces.location import ILocation
from sip.interfaces.container import IContainer
from sip.interfaces.source import ILocationProjectSource
from sip.interfaces.location_project import ILocationProject
from sip.browser import api
from sip import File

class ContainerTreeView(CookieTreeView):

    def canAdd(self):
        return api.checkSIPPermission(self.context, 'sip.AddContainer')

    def cookieTree(self, root=None, filter=None):
        if filter is None:
            filter = OnlyInterfacesFilter(ILocationProject,
                                          IContainer,
                                          ILocationProjectSource,
                                          ILocation,
                                          IShipment,
                                          IOutgoingShipmentState)

        return super(ContainerTreeView, self).cookieTree(
            root=root, filter=filter)


class ModifyContainersCSV(BrowserView):

    modify_containers = File('csv/templates/modify_containers.csv')

    def getCSV(self):
        request = self.request
        context = self.context
        response = request.response
        response.setHeader('content-type', 'application/x-csv')
        response.setHeader('content-disposition',
                               'attachment; filename=modify_containers.csv')
        container_ids = request.get('container_ids', [])
        template = '%s,\r\n'
        data = {}
        data['containers'] = ''
        for id in container_ids:
            path = api.getContainerPathFromId(context, id)
            data['containers'] += template % path
        return str(self.modify_containers) % data
