# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: contents.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.component import ComponentLookupError

from zope.app.browser.container.contents import Contents as BaseContents
from zope.app.pagetemplate.viewpagetemplatefile import ViewPageTemplateFile
from zope.app.container.interfaces import IReadContainer
from interfaces import ILocation
from interfaces.container import IContainer

class Contents(BaseContents):

    normalButtons = True
    specialButtons = False
    supportsRename = False
    supportsCut = False
    supportsPaste = False
    supportsCopy = False

    def _normalListContentsInfo(self):
        try:
            info = super(Contents, self)._normalListContentsInfo()
        except ComponentLookupError:
            info = map(self._extractContentInfo,
                       IReadContainer(self.context).items())
        return info

    def _extractContentInfo(self, item):
        id, obj = item

        info = super(Contents, self)._extractContentInfo(item)

        info['name'] = getattr(obj, 'name', id)
        return info


    def hasClipboardContents(self):
        """ interogates the PrinicipalAnnotation to see if
           clipboard contents exist """
        return False

    def canAddContainer(self):
        """checks to see if we are in a place where we can add containers"""
        context = self.context
        return IContainer.providedBy(context) \
               or ILocation.providedBy(context)

    contents = ViewPageTemplateFile('contents.pt')
