# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

__metaclass__ = type

from pprint import pformat

class MassagerTraceback:

    def __init__(self, row, section, offset=None, template=None, table=None):
        self.row = row
        self.section = section
        self.offset = offset
        self.template = template
        self.table = table

    def getInfo(self):
        result = []
        if self.template is not None:
            result.append('  - template: %s' % self.template)
        if self.section is not None:
            result.append('  - section: %s' % self.section)
        if self.offset is not None:
            result.append('  - offset: %s' % self.offset)
        if self.table is not None:
            result.append('  - section length: %s' % len(self.table))
        result.append(pformat(self.row))
        return "\n".join(result)

class ProcessorTraceback:

    def __init__(self, row, section, offset=None):
        self.row = row
        self.section = section
        self.offset = offset

    def getInfo(self):
        result = []
        if self.section is not None:
            result.append('  - section: %s' % self.section)
        if self.offset is not None:
            result.append('  - offset: %s' % self.offset)
        result.append(pformat(self.row))
        return "\n".join(result)
