# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_labtechnicianrole.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from zope.app.servicenames import Authentication
from zope.exceptions import ForbiddenAttribute, Unauthorized
from sip.ftests.test_reportrole import TestReportRole
from sip.ftests.test_reportrole import TestSQLRole

class TestLabTechRole(TestReportRole):

    _roles = ['sip.Report', 'sip.LabTechnician']
    _principal = 'sip.lab_technician'

    def testAddSample(self):
        view = self._roleAddSample()
        self.failUnless(view())

    def testEditSample(self):
        view = self._roleEditSample()
        self.failUnless(view())

class TestSQLLabTechRole(TestSQLRole, TestLabTechRole): pass

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestLabTechRole))
    suite.addTest(unittest.makeSuite(TestSQLLabTechRole))
    return suite

if __name__ == '__main__':
    unittest.main()
