# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_location.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from zope.app.container.interfaces import IReadContainer
from sip.ftests.base import Base

class TestLocation(Base):
    level = 2
    use_test_user = False

    def testAddLocation(self):
        containertypes = zapi.traverse(self.rootFolder, 'sip/containertypes')
        self.assertEquals(len(containertypes.keys()), 0)
        ct = self._addContainerType()
        self.assertEquals(len(containertypes.keys()), 1)

        locations = zapi.traverse(self.rootFolder, 'sip/locations')
        self.assertEquals(len(locations.keys()), 0)
        self._addLocation(type_id=ct.id)
        self.assertEquals(len(locations.keys()), 1)

    def testAddContainer(self):
        ct = self._addContainerType()
        location = self._addLocation(type_id=ct.id)
        adapted = IReadContainer(location)
        self.assertEquals(len(adapted),0)
        container = self._addContainer(location, ct.id)
        self.assertEquals(len(adapted),1)

    def testAssignLocation(self):
        ct = self._addContainerType()
        location = self._addLocation(type_id=ct.id)
        project = self._addProject()
        valid_locations = project.valid_locations
        locations = zapi.traverse(project, 'locations')
        self.assertEquals(len(valid_locations), 0)
        self.assertEquals(len(locations), 0)
        project.valid_locations = [location.id]
        valid_locations = project.valid_locations
        self.assertEquals(len(valid_locations), 1)
        self.assertEquals(len(locations), 1)


def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestLocation))
    return suite

if __name__ == '__main__':
    unittest.main()
