# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_projectmanagerrole.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from zope.app.servicenames import Authentication
from zope.exceptions import ForbiddenAttribute, Unauthorized
from sip.ftests.test_labtechnicianrole import TestLabTechRole
from sip.ftests.test_reportrole import TestSQLRole
from sip.interfaces.adapter import IPrincipalRolesHelper

class TestPMRole(TestLabTechRole):

    _roles = ['sip.Report', 'sip.LabTechnician', 'sip.ProjectManager']
    _principal = 'sip.project_manager'

    def testAdminProject(self):
        view = self._roleAdminProject()
        self.failUnless(view())

    def testEditProject(self):
        view = self._roleEditProject()
        self.failUnless(view())

class TestSQLPMRole(TestSQLRole, TestPMRole):

    def testAvailableRoles(self):
        project_id = "sip.Project.%s" % self.ids['project']
        project = self.rootFolder['sip']['projects'][project_id]
        adapter = IPrincipalRolesHelper(project)
        roles = adapter.availableRoles()
        self.failIf('sip.AppManager' in roles)
        self.failUnless('sip.ProjectManager' in roles)
        self.failUnless('sip.LabTechnician' in roles)
        self.failUnless('sip.Report' in roles)

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestPMRole))
    suite.addTest(unittest.makeSuite(TestSQLPMRole))
    return suite

if __name__ == '__main__':
    unittest.main()
