# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_rootcreation.py 749 2005-06-28 22:21:49Z sidnei $
"""

from unittest import TestSuite, main, makeSuite
from zope.interface import Interface, implements

from zope.component.service import serviceManager

from zope.app import zapi
from zope.app.container.interfaces import IObjectAddedEvent

from zope.app.servicenames import Utilities, Authentication

from sip.root import AppRoot
from sip.ftests.base import Base
from sip.interfaces.utilities import ISplitDerive, IQuery
from sip.browser.api import queryService

def gp(ob):
    _gp = zapi.getParent
    return _gp(_gp(ob))

class AppRootCreation(Base):
    level = 1

    def test_event_services_creation(self):
        # now for real!
        app = self.sip

        sm = zapi.getServices(app)
        # Check that we didn't got the global SM by mistake
        self.failIf(sm is serviceManager)

        auth = queryService(Authentication, context=app)
        self.failIf(auth is None)
        self.failUnless(gp(auth) is sm)
        self.failUnless('sqlob' in auth)

        util = queryService(Utilities, context=app)
        self.failIf(util is None)
        self.failUnless(gp(util) is sm)

        sq = zapi.queryUtility(IQuery, context=app)
        self.failIf(sq is None)
        self.failUnless(gp(sq) is sm)

        split = zapi.queryUtility(ISplitDerive, context=app)
        self.failIf(split is None)
        self.failUnless(gp(split) is sm)


def test_suite():
    return TestSuite((
        makeSuite(AppRootCreation),
        ))

if __name__=='__main__':
    main(defaultTest='test_suite')
