# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

from unittest import TestSuite, main, makeSuite

from zope.app import zapi
from sip.ftests.base import Base

class TestSourceConstraints(Base):

    use_test_user = False

    def setUp(self):
        super(TestSourceConstraints, self).setUp()
        self.project = self._addProject(name='Foo')
        ctype = self._addContainerType()
        self.location = self._addLocation(type_id=ctype.id, name=u'location')
        self.location2 = self._addLocation(type_id=ctype.id, name=u'location2')
        self.project.valid_locations = [self.location.id]

    def test_constraints(self):
        p_source = zapi.traverse(self.sip, 'projects')
        l_source = zapi.traverse(self.project, 'locations')
        self.assertRaises(KeyError,
                          p_source.__getitem__,
                          'sip.Location.%d' % self.location2.id)
        self.assertRaises(KeyError,
                          l_source.__getitem__,
                          'sip.Location.%d' % self.location2.id)


def test_suite():
    return TestSuite((
        makeSuite(TestSourceConstraints),
        ))

if __name__=='__main__':
    main(defaultTest='test_suite')
