# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_technician.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from sip.ftests.base import Base

class TestTechnician(Base):
    level = 2
    def testAddTechnician(self):
        technicians = zapi.traverse(self.rootFolder, 'sip/technicians')
        self.assertEquals(len(technicians.keys()), 0)
        self._addTechnician()
        self.assertEquals(len(technicians.keys()), 1)

    def testAssignTechnician(self):
        technician = self._addTechnician()
        project = self._addProject()
        valid_technicians = project.valid_technicians
        self.assertEquals(len(valid_technicians), 0)
        project.valid_technicians = [technician.id]
        valid_technicians = project.valid_technicians
        self.assertEquals(len(valid_technicians), 1)

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestTechnician))
    return suite

if __name__ == '__main__':
    unittest.main()
