# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_tree.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from zope.app.container.interfaces import IReadContainer

from sip.ftests.base import Base


class TestTree(Base):
    level = 2
    use_test_user = False

    def _setup(self):
        self.project=self._addProject()
        ct = self._addContainerType()
        location=self._addLocation(ct.id)
        ct = self._addContainerType(root=False, name='box')
        self.container = self._addContainer(location,ct.id)
        self.project.valid_locations = [location.id]

    def testGenerateTree(self):
        self._setup()
        project = self.project
        request = self.request
        project = IReadContainer(project)
        locations = project['locationsproject']
        tree = zapi.getView(locations, 'container_tree.html', request)
        self.failUnless(tree())

    def testGenerateAddTree(self):
        self._setup()
        project = self.project
        request = self.request
        project = IReadContainer(project)
        locations = project['locationsproject']
        tree = zapi.getView(locations, 'container_add_tree.html', request)
        self.failUnless(tree())



def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestTree))
    return suite

if __name__ == '__main__':
    unittest.main()
