# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: test_userrole.py 749 2005-06-28 22:21:49Z sidnei $
"""

import unittest

from zope.app import zapi
from zope.security.management import newInteraction, endInteraction
from zope.app.servicenames import Authentication
from zope.exceptions import ForbiddenAttribute, Unauthorized
from zope.app.securitypolicy.interfaces import IPrincipalRoleManager
from sip.ftests.roles import Roles
from sip.ftests.base import ParticipationStub
from sip.browser import api

class TestUserRole(Roles):

    _role = 'sip.Report'
    _principal = 'sip.user'

    def _setupTestUser(self):
        auth_service = zapi.getService(Authentication)
        user = auth_service.getPrincipal(self._principal)
        endInteraction()
        newInteraction(ParticipationStub(user))

    def testSeeProjects(self):
        projects = self._roleSeeProjects()
        self.failUnless(len(projects) == 0)
        self._setupSystemUser()
        projects = self._roleSeeProjects()
        project = projects[0]
        prm = IPrincipalRoleManager(project)
        prm.assignRoleToPrincipal('sip.Report', self._principal)
        self._setupTestUser()
        projects = self._roleSeeProjects()
        # Should see only one project now, the one where she
        # has the Report role.
        self.failUnless(len(projects) == 1)

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestUserRole))
    return suite

if __name__ == '__main__':
    unittest.main()
