# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: container.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.interface import Interface, Attribute
from zope.schema import TextLine, Int, Bool
from sip.fields import ContainerTypeField
from sip.interfaces import ISIPSchema, Unique, FieldFactory
from sip.descriptors import BoundCallableDescriptor
from sip.i18n import _
class IContainer(Interface):
    """Marker Container Interface"""

class IContainerSchema(ISIPSchema):
    """ """

    name = FieldFactory(
        TextLine,
        title=_('Container Name'),
        description=_('Container Description'),
        required=True,
        constraint=BoundCallableDescriptor(
        Unique(className='sip.Container', columnName='name'))
        )

    type_id = ContainerTypeField(
        title=_('Container Type'),
        description=_('Container Type Description'),
        required=True,
        vocabulary='sip.vocab.container_types')

    parent_id = Attribute('Parent Id')

    location_id = Attribute('Location Id')


class IContainerAddSchema(IContainerSchema):
    """ """

    rows = Int(title=_('Rows'),
               description=_('Number of rows'),
               required=False,
               default=1)
    columns = Int(title=_('Columns'),
                  description=u'Number of columns',
                  required=False,
                  default=1)
