# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: containertype.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.schema import TextLine, Bool

from sip.interfaces import ISIPSchema, Unique, FieldFactory
from sip.descriptors import BoundCallableDescriptor
from sip.i18n import _

class IContainerType(ISIPSchema):
    """ """

    name = FieldFactory(
        TextLine,
        title=_('Type Name'),
        description=_('Container Type Name Description'),
        constraint=BoundCallableDescriptor(
        Unique(className='sip.ContainerType', columnName='name'))
        )

    root = Bool(title=_('Root Container?'),
                description=_('Only allowed to be used for root containers'),
                required=False)
