# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: fields.py 749 2005-06-28 22:21:49Z sidnei $
"""

from zope.interface import implements, Interface
from zope.schema import TextLine, Bool, Text, Field
from zope.schema.interfaces import IText
from zope.tales.tales import Undefined, CompilerError
from zope.app.pagetemplate.engine import Engine

from sip.i18n import _

class ICommitMessage(IText):
    """ A Commit Message field. Nothing special, just a
    marker interface to allow using a special widget. """

class IBRField(Interface):
    """marker interface for linebreaks in forms"""

class ISubjectTypeField(Interface):
    """marker to use radio widget"""

class IROSubjectTypeWidget(Interface):
    """marker interface"""

def TALESExpressionConstraint(value):
    assert not value.startswith('string'), ('We only accept python: '
                                            'TALES expressions')
    if not value.startswith('python:'):
        value = "python: %s" % value
    try:
        compiled = Engine.compile(value)
    except (SyntaxError, CompilerError, Undefined):
        return False
    else:
        return True

class ITALESExpressionField(Interface):
    """ marker interface """

class IInAndOutField(Interface):
    """marker interface"""

class TALESExpressionField(TextLine):
    implements(ITALESExpressionField)

class ITALESConstrainedField(Interface):
    """A marker interface for fields which have a TALES
    constraint"""
    expression = TALESExpressionField(title=_('TALES Expression'),
                          description=_(('A TALES Expression. '
                                         'the variables you have available '
                                         'are: value, nothing.')),
                          constraint=TALESExpressionConstraint,
                          required=False)

    def __call__(value):
        """Evaluate the TALES expression, using value
        and return True if its a valid value, or raise a
        ValidationError."""
