# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

from zope.interface import implements
from sip.interfaces.services import IGlobalAppContainerRegistry

class GlobalAppContainerRegistry:

    implements(IGlobalAppContainerRegistry)

    def __init__(self):
        self.__registry = {}

    def registerContainer(self, klass, name=''):
        """ See IGlobalProjectService interface """
        if not name:
            name = "%s" % klass.__name__
        self.__registry[name] = klass

    def queryContainers(self, context=None):
        """ See IGlobalProjectService interface """
        containers = {}
        for name, klass in self.__registry.iteritems():
            containers[name] = klass(context=context)
        return containers

    def getNames(self):
        """ See IGlobalProjectService interface """
        return self.__registry.keys()

service = GlobalAppContainerRegistry()
queryContainers = service.queryContainers
registerContainer = service.registerContainer
