--
-- PostgreSQL database dump
--

SET client_encoding = 'SQL_ASCII';
SET check_function_bodies = false;

SET SESSION AUTHORIZATION 'zope3';

SET search_path = public, pg_catalog;

DROP TRIGGER remove_id_from_pool ON public.aliquot;
ALTER TABLE ONLY public.shipping_info DROP CONSTRAINT si_method_exists;
ALTER TABLE ONLY public.shipping_info DROP CONSTRAINT si_tech_exists;
ALTER TABLE ONLY public.funding_info DROP CONSTRAINT funding_source_exists;
ALTER TABLE ONLY public.funding_info DROP CONSTRAINT shipment_exists;
ALTER TABLE ONLY public.container_location DROP CONSTRAINT location_exists;
ALTER TABLE ONLY public.container_location DROP CONSTRAINT container_exists;
ALTER TABLE ONLY public.shipment DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.container_shipment DROP CONSTRAINT container_exists;
ALTER TABLE ONLY public.container_shipment DROP CONSTRAINT shipment_exists;
ALTER TABLE ONLY public.shipment DROP CONSTRAINT shipping_info_exists;
ALTER TABLE ONLY public.shipment DROP CONSTRAINT contact_info_exists;
ALTER TABLE ONLY public.shipping_info DROP CONSTRAINT carrier_exists;
ALTER TABLE ONLY public.sample DROP CONSTRAINT subject_type_exists;
ALTER TABLE ONLY public.origin_sample_aliquots DROP CONSTRAINT sample_exists;
ALTER TABLE ONLY public.origin_sample_aliquots DROP CONSTRAINT aliquot_exist;
ALTER TABLE ONLY public.additional_sample_data DROP CONSTRAINT schema_field_exists;
ALTER TABLE ONLY public.additional_sample_data DROP CONSTRAINT sample_exists;
ALTER TABLE ONLY public.schema_field DROP CONSTRAINT sample_type_schema_exists;
ALTER TABLE ONLY public.sample_type_schema DROP CONSTRAINT sample_type_exists;
ALTER TABLE ONLY public.sample_type_schema DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT container_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT concentration_unit_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT weight_unit_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT volume_unit_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT sample_exists;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.container DROP CONSTRAINT container_type_exists;
ALTER TABLE ONLY public.container DROP CONSTRAINT container_exists;
ALTER TABLE ONLY public.sample DROP CONSTRAINT technician_exists;
ALTER TABLE ONLY public.sample DROP CONSTRAINT sample_type_exists;
ALTER TABLE ONLY public.sample DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.sample_type_project DROP CONSTRAINT sample_type_exists;
ALTER TABLE ONLY public.sample_type_project DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.location_project DROP CONSTRAINT location_exists;
ALTER TABLE ONLY public.location_project DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.technician_project DROP CONSTRAINT technician_exists;
ALTER TABLE ONLY public.technician_project DROP CONSTRAINT project_exists;
ALTER TABLE ONLY public.temp_method DROP CONSTRAINT temp_method_pkey;
ALTER TABLE ONLY public.funding_info DROP CONSTRAINT funding_info_pkey;
ALTER TABLE ONLY public.funding_source DROP CONSTRAINT funding_source_pkey;
ALTER TABLE ONLY public.container_location DROP CONSTRAINT container_location_pkey;
ALTER TABLE ONLY public.container_shipment DROP CONSTRAINT container_shipment_pkey;
ALTER TABLE ONLY public.shipment DROP CONSTRAINT shipment_pkey;
ALTER TABLE ONLY public.shipping_info DROP CONSTRAINT shipping_info_pkey;
ALTER TABLE ONLY public.contact_info DROP CONSTRAINT contact_info_pkey;
ALTER TABLE ONLY public.carrier DROP CONSTRAINT carrier_pkey;
ALTER TABLE ONLY public."location" DROP CONSTRAINT unique_location_name;
ALTER TABLE ONLY public.container DROP CONSTRAINT unique_name_per_parent;
ALTER TABLE ONLY public.aliquot_allocation DROP CONSTRAINT aliquot_allocation_aliquot_id_key;
ALTER TABLE ONLY public.sample DROP CONSTRAINT unique_name_per_project;
ALTER TABLE ONLY public.additional_sample_data DROP CONSTRAINT additional_sample_data_pkey;
ALTER TABLE ONLY public.schema_field DROP CONSTRAINT schema_field_pkey;
ALTER TABLE ONLY public.sample_type_schema DROP CONSTRAINT sample_type_schema_pkey;
ALTER TABLE ONLY public.security_role DROP CONSTRAINT security_role_pkey;
ALTER TABLE ONLY public.security_principal DROP CONSTRAINT security_principal_pkey;
ALTER TABLE ONLY public.aliquot DROP CONSTRAINT aliquot_pkey;
ALTER TABLE ONLY public.weight_unit DROP CONSTRAINT weight_unit_pkey;
ALTER TABLE ONLY public.volume_unit DROP CONSTRAINT volume_unit_pkey;
ALTER TABLE ONLY public.concentration_unit DROP CONSTRAINT concentration_unit_pkey;
ALTER TABLE ONLY public.container DROP CONSTRAINT container_pkey;
ALTER TABLE ONLY public.container_type DROP CONSTRAINT container_type_pkey;
ALTER TABLE ONLY public.sample DROP CONSTRAINT sample_pkey;
ALTER TABLE ONLY public.subject_type DROP CONSTRAINT subject_type_pkey;
ALTER TABLE ONLY public.sample_type_project DROP CONSTRAINT sample_type_project_pkey;
ALTER TABLE ONLY public.sample_type DROP CONSTRAINT sample_type_pkey;
ALTER TABLE ONLY public.location_project DROP CONSTRAINT location_project_pkey;
ALTER TABLE ONLY public."location" DROP CONSTRAINT location_pkey;
ALTER TABLE ONLY public.technician_project DROP CONSTRAINT technician_project_pkey;
ALTER TABLE ONLY public.technician DROP CONSTRAINT technician_pkey;
ALTER TABLE ONLY public.principal DROP CONSTRAINT principal_pkey;
ALTER TABLE ONLY public.project DROP CONSTRAINT project_pkey;
DROP INDEX public.sample_type_schema_project_sample_type_idx;
DROP INDEX public.schema_field_name_schema_id_idx;
DROP INDEX public.schema_field_schema_id_idx;
DROP INDEX public.tp_project_id_idx;
DROP INDEX public.sr_role_location_idx;
DROP INDEX public.sp_principal_location_idx;
DROP INDEX public.sample_name_idx;
DROP INDEX public.sample_derived_idx;
DROP INDEX public.sample_type_id_idx;
DROP INDEX public.sample_project_id_idx;
DROP INDEX public.lp_project_id_idx;
DROP INDEX public.container_type_id_idx;
DROP INDEX public.container_parent_id_idx;
DROP INDEX public.aliquot_date_idx;
DROP INDEX public.aliquot_depleted_idx;
DROP INDEX public.aliquot_container_id_idx;
DROP INDEX public.aliquot_project_id_sample_id_idx;
DROP INDEX public.aliquot_sample_id_idx;
DROP INDEX public.aliquot_project_id_idx;
DROP INDEX public.ad_sample_id_idx;
SET SESSION AUTHORIZATION 'postgres';

DROP FUNCTION public.remove_id();
DROP FUNCTION public.get_aliquot_ids(integer);
DROP FUNCTION public.select_on_info(integer, character varying, text);
DROP FUNCTION public.get_field_id(integer, character varying, character varying);
DROP FUNCTION public.clear_project(character varying);
SET SESSION AUTHORIZATION 'zope3';

DROP TABLE public.temp_method;
DROP TABLE public.funding_info;
DROP TABLE public.funding_source;
DROP TABLE public.container_location;
DROP TABLE public.container_shipment;
DROP TABLE public.shipment;
DROP TABLE public.shipping_info;
DROP TABLE public.contact_info;
DROP TABLE public.carrier;
DROP TABLE public.additional_sample_data;
DROP TABLE public.schema_field;
DROP TABLE public.sample_type_schema;
DROP TABLE public.security_role;
DROP TABLE public.security_principal;
DROP TABLE public.aliquot;
DROP TABLE public.weight_unit;
DROP TABLE public.volume_unit;
DROP TABLE public.concentration_unit;
DROP TABLE public.container;
DROP TABLE public.container_type;
DROP TABLE public.sample;
DROP TABLE public.subject_type;
DROP TABLE public.sample_type_project;
DROP TABLE public.sample_type;
DROP TABLE public.location_project;
DROP TABLE public."location";
DROP TABLE public.technician_project;
DROP TABLE public.technician;
DROP TABLE public.principal;
DROP TABLE public.project;
DROP TABLE public.aliquot_allocation;
DROP TABLE public.origin_sample_aliquots;
SET SESSION AUTHORIZATION DEFAULT;

DROP PROCEDURAL LANGUAGE plpgsql;
SET SESSION AUTHORIZATION 'postgres';

DROP FUNCTION public.plpgsql_call_handler();
--
-- TOC entry 92 (OID 1010525)
-- Name: plpgsql_call_handler(); Type: FUNC PROCEDURAL LANGUAGE; Schema: public; Owner: postgres
--

CREATE FUNCTION plpgsql_call_handler() RETURNS language_handler
    AS '$libdir/plpgsql', 'plpgsql_call_handler'
    LANGUAGE c;


SET SESSION AUTHORIZATION DEFAULT;

--
-- TOC entry 91 (OID 1010526)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: public; Owner: 
--

CREATE TRUSTED PROCEDURAL LANGUAGE plpgsql HANDLER plpgsql_call_handler;


SET SESSION AUTHORIZATION 'zope3';

--
-- TOC entry 4 (OID 23533)
-- Name: public; Type: ACL; Schema: -; Owner: zope3
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- TOC entry 5 (OID 1010529)
-- Name: origin_sample_aliquots; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE origin_sample_aliquots (
    id serial NOT NULL,
    aliquot_id integer NOT NULL,
    sample_id integer NOT NULL
);


--
-- TOC entry 6 (OID 1010532)
-- Name: aliquot_allocation; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE aliquot_allocation (
    aliquot_id integer NOT NULL,
    status text NOT NULL,
    tstamp timestamp without time zone DEFAULT now() NOT NULL
);


--
-- TOC entry 7 (OID 1010540)
-- Name: project; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE project (
    project_id serial NOT NULL,
    name character varying(255) NOT NULL,
    commit_message text NOT NULL,
    start_date date NOT NULL,
    end_date date,
    require_commit_message boolean
);


--
-- TOC entry 8 (OID 1010548)
-- Name: principal; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE principal (
    principal_id serial NOT NULL,
    username text NOT NULL,
    fullname text,
    "password" text NOT NULL,
    start_date date NOT NULL,
    end_date date
);


--
-- TOC entry 9 (OID 1010556)
-- Name: technician; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE technician (
    technician_id serial NOT NULL,
    username character varying(255) NOT NULL,
    fullname character varying(255),
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 10 (OID 1010564)
-- Name: technician_project; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE technician_project (
    technician_project_id serial NOT NULL,
    project_id integer,
    technician_id integer
);


--
-- TOC entry 11 (OID 1010569)
-- Name: location; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE "location" (
    location_id serial NOT NULL,
    name character varying(255) NOT NULL,
    building character varying(255),
    room character varying(255),
    temperature integer,
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 12 (OID 1010577)
-- Name: location_project; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE location_project (
    location_project_id serial NOT NULL,
    project_id integer,
    location_id integer
);


--
-- TOC entry 13 (OID 1010582)
-- Name: sample_type; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE sample_type (
    sample_type_id serial NOT NULL,
    name character varying(255) NOT NULL,
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 14 (OID 1010590)
-- Name: sample_type_project; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE sample_type_project (
    sample_type_project_id serial NOT NULL,
    project_id integer,
    sample_type_id integer
);


--
-- TOC entry 15 (OID 1010595)
-- Name: subject_type; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE subject_type (
    subject_type_id serial NOT NULL,
    name character varying(255) NOT NULL
);


--
-- TOC entry 16 (OID 1010600)
-- Name: sample; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE sample (
    sample_id serial NOT NULL,
    name character varying(255),
    other_id character varying(255),
    date_generated date NOT NULL,
    comments text,
    subject_id character varying(255),
    project_id integer,
    type_id integer,
    technician_id integer,
    derived boolean NOT NULL,
    commit_message text NOT NULL,
    collection_date date,
    subject_type_id integer
);


--
-- TOC entry 17 (OID 1010608)
-- Name: container_type; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE container_type (
    container_type_id serial NOT NULL,
    name character varying(255) NOT NULL,
    start_date date NOT NULL,
    end_date date,
    root boolean NOT NULL,
    commit_message text NOT NULL
);


--
-- TOC entry 18 (OID 1010616)
-- Name: container; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE container (
    container_id serial NOT NULL,
    name character varying(255) NOT NULL,
    parent_id integer,
    type_id integer,
    commit_message text NOT NULL
);


--
-- TOC entry 19 (OID 1010624)
-- Name: concentration_unit; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE concentration_unit (
    concentration_unit_id serial NOT NULL,
    label character varying(255) NOT NULL,
    description character varying(255) NOT NULL,
    exponent numeric(24,18) NOT NULL,
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 20 (OID 1010632)
-- Name: volume_unit; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE volume_unit (
    volume_unit_id serial NOT NULL,
    label character varying(255) NOT NULL,
    description character varying(255) NOT NULL,
    exponent numeric(24,18) NOT NULL,
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 21 (OID 1010640)
-- Name: weight_unit; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE weight_unit (
    weight_unit_id serial NOT NULL,
    label character varying(255) NOT NULL,
    description character varying(255) NOT NULL,
    exponent numeric(24,18) NOT NULL,
    start_date date NOT NULL,
    end_date date,
    commit_message text NOT NULL
);


--
-- TOC entry 22 (OID 1010648)
-- Name: aliquot; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE aliquot (
    aliquot_id serial NOT NULL,
    project_id integer,
    sample_id integer,
    volume_id integer,
    weight_id integer,
    concentration_id integer,
    container_id integer,
    depleted boolean NOT NULL,
    date date NOT NULL,
    commit_message text NOT NULL,
    is_low boolean NOT NULL,
    aliquot_count integer,
    concentration numeric(24,18),
    volume numeric(24,18),
    weight numeric(24,18),
    "comment" text
);


--
-- TOC entry 23 (OID 1010656)
-- Name: security_principal; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE security_principal (
    id serial NOT NULL,
    principal_id character varying(255) NOT NULL,
    role_id character varying(255),
    "location" character varying(255) NOT NULL,
    value integer NOT NULL
);


--
-- TOC entry 24 (OID 1010661)
-- Name: security_role; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE security_role (
    id serial NOT NULL,
    role_id character varying(255) NOT NULL,
    principal_id character varying(255),
    "location" character varying(255) NOT NULL,
    value integer NOT NULL
);


--
-- TOC entry 25 (OID 1010666)
-- Name: sample_type_schema; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE sample_type_schema (
    sample_type_schema_id serial NOT NULL,
    project_id integer,
    sample_type_id integer,
    start_date date NOT NULL,
    end_date date
);


--
-- TOC entry 26 (OID 1010671)
-- Name: schema_field; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE schema_field (
    schema_field_id serial NOT NULL,
    schema_id integer,
    name text NOT NULL,
    "type" text NOT NULL,
    title text,
    description text,
    default_value text,
    required boolean NOT NULL,
    readonly boolean NOT NULL,
    field_order integer NOT NULL,
    tales boolean NOT NULL,
    tales_expression text NOT NULL,
    start_date date NOT NULL,
    end_date date
);


--
-- TOC entry 27 (OID 1010679)
-- Name: additional_sample_data; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE additional_sample_data (
    additional_sample_data_id serial NOT NULL,
    sample_id integer,
    schema_field_id integer,
    value text
);


--
-- TOC entry 28 (OID 1010687)
-- Name: carrier; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE carrier (
    carrier_id serial NOT NULL,
    name character varying(255) NOT NULL
);


--
-- TOC entry 29 (OID 1010692)
-- Name: contact_info; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE contact_info (
    contact_info_id serial NOT NULL,
    firstname character varying(255),
    lastname character varying(255),
    institution character varying(255),
    address1 character varying(255),
    address2 character varying(255),
    city character varying(255),
    state character varying(255),
    zipcode character varying(255),
    country character varying(255),
    phone character varying(255),
    fax character varying(255),
    email character varying(255),
    project character varying(255),
    objective text,
    commit_message text NOT NULL
);


--
-- TOC entry 30 (OID 1010700)
-- Name: shipping_info; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE shipping_info (
    shipping_info_id serial NOT NULL,
    hand_delivered boolean,
    carrier_id integer,
    account_number character varying(255),
    tracking_number character varying(255),
    instructions text,
    commit_message text NOT NULL,
    newcontainer boolean DEFAULT false,
    housenumber character varying(255),
    technician_id integer,
    temp_method_id integer
);


--
-- TOC entry 31 (OID 1010709)
-- Name: shipment; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE shipment (
    shipment_id serial NOT NULL,
    planneddate date,
    requestdate date,
    shipdate date,
    receivedate date,
    infectious boolean DEFAULT false,
    biohazard boolean DEFAULT false,
    contact_info_id integer,
    shipping_info_id integer,
    project_id integer,
    name character varying(255) NOT NULL,
    commit_message text NOT NULL,
    returndate date
);


--
-- TOC entry 32 (OID 1010719)
-- Name: container_shipment; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE container_shipment (
    container_shipment_id serial NOT NULL,
    shipment_id integer,
    container_id integer
);


--
-- TOC entry 33 (OID 1010724)
-- Name: container_location; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE container_location (
    container_location_id serial NOT NULL,
    container_id integer NOT NULL,
    location_id integer NOT NULL
);


--
-- TOC entry 34 (OID 1010729)
-- Name: funding_source; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE funding_source (
    funding_source_id serial NOT NULL,
    name character varying(255) NOT NULL,
    federal boolean NOT NULL
);


--
-- TOC entry 35 (OID 1010734)
-- Name: funding_info; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE funding_info (
    funding_info_id serial NOT NULL,
    shipment_id integer NOT NULL,
    funding_source_id integer,
    grant_number character varying(255),
    cost numeric(14,2),
    agency character varying(255),
    principal character varying(255),
    state character varying(255),
    enddate date,
    fee numeric(11,2),
    commit_message text NOT NULL
);


--
-- TOC entry 36 (OID 1010742)
-- Name: temp_method; Type: TABLE; Schema: public; Owner: zope3
--

CREATE TABLE temp_method (
    temp_method_id serial NOT NULL,
    name character varying(255) NOT NULL
);



--
-- TOC entry 80 (OID 1010763)
-- Name: ad_sample_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX ad_sample_id_idx ON additional_sample_data USING btree (sample_id, schema_field_id);


--
-- TOC entry 68 (OID 1010764)
-- Name: aliquot_project_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_project_id_idx ON aliquot USING btree (project_id);


--
-- TOC entry 70 (OID 1010765)
-- Name: aliquot_sample_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_sample_id_idx ON aliquot USING btree (sample_id);


--
-- TOC entry 69 (OID 1010766)
-- Name: aliquot_project_id_sample_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_project_id_sample_id_idx ON aliquot USING btree (project_id, sample_id);


--
-- TOC entry 64 (OID 1010767)
-- Name: aliquot_container_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_container_id_idx ON aliquot USING btree (container_id);


--
-- TOC entry 66 (OID 1010768)
-- Name: aliquot_depleted_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_depleted_idx ON aliquot USING btree (depleted);


--
-- TOC entry 65 (OID 1010769)
-- Name: aliquot_date_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX aliquot_date_idx ON aliquot USING btree (date);


--
-- TOC entry 57 (OID 1010770)
-- Name: container_parent_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX container_parent_id_idx ON container USING btree (parent_id);


--
-- TOC entry 59 (OID 1010771)
-- Name: container_type_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX container_type_id_idx ON container USING btree (type_id);


--
-- TOC entry 46 (OID 1010772)
-- Name: lp_project_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX lp_project_id_idx ON location_project USING btree (project_id);


--
-- TOC entry 53 (OID 1010773)
-- Name: sample_project_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sample_project_id_idx ON sample USING btree (project_id);


--
-- TOC entry 54 (OID 1010774)
-- Name: sample_type_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sample_type_id_idx ON sample USING btree (type_id);


--
-- TOC entry 50 (OID 1010775)
-- Name: sample_derived_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sample_derived_idx ON sample USING btree (derived);


--
-- TOC entry 51 (OID 1010776)
-- Name: sample_name_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sample_name_idx ON sample USING btree (name);


--
-- TOC entry 72 (OID 1010777)
-- Name: sp_principal_location_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sp_principal_location_idx ON security_principal USING btree (principal_id, "location");


--
-- TOC entry 74 (OID 1010778)
-- Name: sr_role_location_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sr_role_location_idx ON security_role USING btree (role_id, "location");


--
-- TOC entry 42 (OID 1010779)
-- Name: tp_project_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX tp_project_id_idx ON technician_project USING btree (project_id);


--
-- TOC entry 79 (OID 1010780)
-- Name: schema_field_schema_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX schema_field_schema_id_idx ON schema_field USING btree (schema_id);


--
-- TOC entry 77 (OID 1010781)
-- Name: schema_field_name_schema_id_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX schema_field_name_schema_id_idx ON schema_field USING btree (name, schema_id);


--
-- TOC entry 76 (OID 1010782)
-- Name: sample_type_schema_project_sample_type_idx; Type: INDEX; Schema: public; Owner: zope3
--

CREATE INDEX sample_type_schema_project_sample_type_idx ON sample_type_schema USING btree (project_id, sample_type_id);


--
-- TOC entry 38 (OID 1010783)
-- Name: project_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY project
    ADD CONSTRAINT project_pkey PRIMARY KEY (project_id);


--
-- TOC entry 39 (OID 1010785)
-- Name: principal_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY principal
    ADD CONSTRAINT principal_pkey PRIMARY KEY (principal_id);


--
-- TOC entry 40 (OID 1010787)
-- Name: technician_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY technician
    ADD CONSTRAINT technician_pkey PRIMARY KEY (technician_id);


--
-- TOC entry 41 (OID 1010789)
-- Name: technician_project_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY technician_project
    ADD CONSTRAINT technician_project_pkey PRIMARY KEY (technician_project_id);


--
-- TOC entry 43 (OID 1010791)
-- Name: location_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY "location"
    ADD CONSTRAINT location_pkey PRIMARY KEY (location_id);


--
-- TOC entry 45 (OID 1010793)
-- Name: location_project_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY location_project
    ADD CONSTRAINT location_project_pkey PRIMARY KEY (location_project_id);


--
-- TOC entry 47 (OID 1010795)
-- Name: sample_type_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type
    ADD CONSTRAINT sample_type_pkey PRIMARY KEY (sample_type_id);


--
-- TOC entry 48 (OID 1010797)
-- Name: sample_type_project_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_project
    ADD CONSTRAINT sample_type_project_pkey PRIMARY KEY (sample_type_project_id);


--
-- TOC entry 49 (OID 1010799)
-- Name: subject_type_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY subject_type
    ADD CONSTRAINT subject_type_pkey PRIMARY KEY (subject_type_id);


--
-- TOC entry 52 (OID 1010801)
-- Name: sample_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT sample_pkey PRIMARY KEY (sample_id);


--
-- TOC entry 56 (OID 1010803)
-- Name: container_type_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_type
    ADD CONSTRAINT container_type_pkey PRIMARY KEY (container_type_id);


--
-- TOC entry 58 (OID 1010805)
-- Name: container_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container
    ADD CONSTRAINT container_pkey PRIMARY KEY (container_id);


--
-- TOC entry 61 (OID 1010807)
-- Name: concentration_unit_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY concentration_unit
    ADD CONSTRAINT concentration_unit_pkey PRIMARY KEY (concentration_unit_id);


--
-- TOC entry 62 (OID 1010809)
-- Name: volume_unit_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY volume_unit
    ADD CONSTRAINT volume_unit_pkey PRIMARY KEY (volume_unit_id);


--
-- TOC entry 63 (OID 1010811)
-- Name: weight_unit_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY weight_unit
    ADD CONSTRAINT weight_unit_pkey PRIMARY KEY (weight_unit_id);


--
-- TOC entry 67 (OID 1010813)
-- Name: aliquot_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT aliquot_pkey PRIMARY KEY (aliquot_id);


--
-- TOC entry 71 (OID 1010815)
-- Name: security_principal_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY security_principal
    ADD CONSTRAINT security_principal_pkey PRIMARY KEY (id);


--
-- TOC entry 73 (OID 1010817)
-- Name: security_role_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY security_role
    ADD CONSTRAINT security_role_pkey PRIMARY KEY (id);


--
-- TOC entry 75 (OID 1010819)
-- Name: sample_type_schema_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_schema
    ADD CONSTRAINT sample_type_schema_pkey PRIMARY KEY (sample_type_schema_id);


--
-- TOC entry 78 (OID 1010821)
-- Name: schema_field_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY schema_field
    ADD CONSTRAINT schema_field_pkey PRIMARY KEY (schema_field_id);


--
-- TOC entry 81 (OID 1010823)
-- Name: additional_sample_data_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY additional_sample_data
    ADD CONSTRAINT additional_sample_data_pkey PRIMARY KEY (additional_sample_data_id);


--
-- TOC entry 55 (OID 1010825)
-- Name: unique_name_per_project; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT unique_name_per_project UNIQUE (name, project_id);


--
-- TOC entry 37 (OID 1010827)
-- Name: aliquot_allocation_aliquot_id_key; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot_allocation
    ADD CONSTRAINT aliquot_allocation_aliquot_id_key UNIQUE (aliquot_id);


--
-- TOC entry 60 (OID 1010829)
-- Name: unique_name_per_parent; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container
    ADD CONSTRAINT unique_name_per_parent UNIQUE (name, parent_id);


--
-- TOC entry 44 (OID 1010831)
-- Name: unique_location_name; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY "location"
    ADD CONSTRAINT unique_location_name UNIQUE (name);


--
-- TOC entry 82 (OID 1010833)
-- Name: carrier_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY carrier
    ADD CONSTRAINT carrier_pkey PRIMARY KEY (carrier_id);


--
-- TOC entry 83 (OID 1010835)
-- Name: contact_info_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY contact_info
    ADD CONSTRAINT contact_info_pkey PRIMARY KEY (contact_info_id);


--
-- TOC entry 84 (OID 1010837)
-- Name: shipping_info_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipping_info
    ADD CONSTRAINT shipping_info_pkey PRIMARY KEY (shipping_info_id);


--
-- TOC entry 85 (OID 1010839)
-- Name: shipment_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipment
    ADD CONSTRAINT shipment_pkey PRIMARY KEY (shipment_id);


--
-- TOC entry 86 (OID 1010841)
-- Name: container_shipment_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_shipment
    ADD CONSTRAINT container_shipment_pkey PRIMARY KEY (container_shipment_id);


--
-- TOC entry 87 (OID 1010843)
-- Name: container_location_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_location
    ADD CONSTRAINT container_location_pkey PRIMARY KEY (container_location_id);


--
-- TOC entry 88 (OID 1010845)
-- Name: funding_source_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY funding_source
    ADD CONSTRAINT funding_source_pkey PRIMARY KEY (funding_source_id);


--
-- TOC entry 89 (OID 1010847)
-- Name: funding_info_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY funding_info
    ADD CONSTRAINT funding_info_pkey PRIMARY KEY (funding_info_id);


--
-- TOC entry 90 (OID 1010849)
-- Name: temp_method_pkey; Type: CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY temp_method
    ADD CONSTRAINT temp_method_pkey PRIMARY KEY (temp_method_id);


--
-- TOC entry 100 (OID 1010851)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY technician_project
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 101 (OID 1010855)
-- Name: technician_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY technician_project
    ADD CONSTRAINT technician_exists FOREIGN KEY (technician_id) REFERENCES technician(technician_id) ON DELETE RESTRICT;


--
-- TOC entry 102 (OID 1010859)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY location_project
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 103 (OID 1010863)
-- Name: location_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY location_project
    ADD CONSTRAINT location_exists FOREIGN KEY (location_id) REFERENCES "location"(location_id) ON DELETE RESTRICT;


--
-- TOC entry 104 (OID 1010867)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_project
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 105 (OID 1010871)
-- Name: sample_type_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_project
    ADD CONSTRAINT sample_type_exists FOREIGN KEY (sample_type_id) REFERENCES sample_type(sample_type_id) ON DELETE RESTRICT;


--
-- TOC entry 106 (OID 1010875)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 107 (OID 1010879)
-- Name: sample_type_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT sample_type_exists FOREIGN KEY (type_id) REFERENCES sample_type(sample_type_id) ON DELETE RESTRICT;


--
-- TOC entry 108 (OID 1010883)
-- Name: technician_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT technician_exists FOREIGN KEY (technician_id) REFERENCES technician(technician_id) ON DELETE RESTRICT;


--
-- TOC entry 110 (OID 1010887)
-- Name: container_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container
    ADD CONSTRAINT container_exists FOREIGN KEY (parent_id) REFERENCES container(container_id) ON DELETE RESTRICT;


--
-- TOC entry 111 (OID 1010891)
-- Name: container_type_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container
    ADD CONSTRAINT container_type_exists FOREIGN KEY (type_id) REFERENCES container_type(container_type_id) ON DELETE RESTRICT;


--
-- TOC entry 112 (OID 1010895)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 113 (OID 1010899)
-- Name: sample_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT sample_exists FOREIGN KEY (sample_id) REFERENCES sample(sample_id) ON DELETE RESTRICT;


--
-- TOC entry 114 (OID 1010903)
-- Name: volume_unit_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT volume_unit_exists FOREIGN KEY (volume_id) REFERENCES volume_unit(volume_unit_id) ON DELETE RESTRICT;


--
-- TOC entry 115 (OID 1010907)
-- Name: weight_unit_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT weight_unit_exists FOREIGN KEY (weight_id) REFERENCES weight_unit(weight_unit_id) ON DELETE RESTRICT;


--
-- TOC entry 116 (OID 1010911)
-- Name: concentration_unit_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT concentration_unit_exists FOREIGN KEY (concentration_id) REFERENCES concentration_unit(concentration_unit_id) ON DELETE RESTRICT;


--
-- TOC entry 117 (OID 1010915)
-- Name: container_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY aliquot
    ADD CONSTRAINT container_exists FOREIGN KEY (container_id) REFERENCES container(container_id) ON DELETE RESTRICT;


--
-- TOC entry 118 (OID 1010919)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_schema
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 119 (OID 1010923)
-- Name: sample_type_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample_type_schema
    ADD CONSTRAINT sample_type_exists FOREIGN KEY (sample_type_id) REFERENCES sample_type(sample_type_id) ON DELETE RESTRICT;


--
-- TOC entry 120 (OID 1010927)
-- Name: sample_type_schema_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY schema_field
    ADD CONSTRAINT sample_type_schema_exists FOREIGN KEY (schema_id) REFERENCES sample_type_schema(sample_type_schema_id) ON DELETE RESTRICT;


--
-- TOC entry 121 (OID 1010931)
-- Name: sample_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY additional_sample_data
    ADD CONSTRAINT sample_exists FOREIGN KEY (sample_id) REFERENCES sample(sample_id) ON DELETE RESTRICT;


--
-- TOC entry 122 (OID 1010935)
-- Name: schema_field_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY additional_sample_data
    ADD CONSTRAINT schema_field_exists FOREIGN KEY (schema_field_id) REFERENCES schema_field(schema_field_id) ON DELETE RESTRICT;


--
-- TOC entry 98 (OID 1010939)
-- Name: aliquot_exist; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY origin_sample_aliquots
    ADD CONSTRAINT aliquot_exist FOREIGN KEY (aliquot_id) REFERENCES aliquot(aliquot_id) ON DELETE RESTRICT;


--
-- TOC entry 99 (OID 1010943)
-- Name: sample_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY origin_sample_aliquots
    ADD CONSTRAINT sample_exists FOREIGN KEY (sample_id) REFERENCES sample(sample_id) ON DELETE RESTRICT;


--
-- TOC entry 109 (OID 1010947)
-- Name: subject_type_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY sample
    ADD CONSTRAINT subject_type_exists FOREIGN KEY (subject_type_id) REFERENCES subject_type(subject_type_id) ON DELETE RESTRICT;


--
-- TOC entry 123 (OID 1010951)
-- Name: carrier_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipping_info
    ADD CONSTRAINT carrier_exists FOREIGN KEY (carrier_id) REFERENCES carrier(carrier_id) ON DELETE RESTRICT;


--
-- TOC entry 126 (OID 1010955)
-- Name: contact_info_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipment
    ADD CONSTRAINT contact_info_exists FOREIGN KEY (contact_info_id) REFERENCES contact_info(contact_info_id) ON DELETE RESTRICT;


--
-- TOC entry 127 (OID 1010959)
-- Name: shipping_info_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipment
    ADD CONSTRAINT shipping_info_exists FOREIGN KEY (shipping_info_id) REFERENCES shipping_info(shipping_info_id) ON DELETE RESTRICT;


--
-- TOC entry 129 (OID 1010963)
-- Name: shipment_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_shipment
    ADD CONSTRAINT shipment_exists FOREIGN KEY (shipment_id) REFERENCES shipment(shipment_id) ON DELETE RESTRICT;


--
-- TOC entry 130 (OID 1010967)
-- Name: container_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_shipment
    ADD CONSTRAINT container_exists FOREIGN KEY (container_id) REFERENCES container(container_id) ON DELETE RESTRICT;


--
-- TOC entry 128 (OID 1010971)
-- Name: project_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipment
    ADD CONSTRAINT project_exists FOREIGN KEY (project_id) REFERENCES project(project_id) ON DELETE RESTRICT;


--
-- TOC entry 131 (OID 1010975)
-- Name: container_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_location
    ADD CONSTRAINT container_exists FOREIGN KEY (container_id) REFERENCES container(container_id) ON DELETE RESTRICT;


--
-- TOC entry 132 (OID 1010979)
-- Name: location_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY container_location
    ADD CONSTRAINT location_exists FOREIGN KEY (location_id) REFERENCES "location"(location_id) ON DELETE RESTRICT;


--
-- TOC entry 133 (OID 1010983)
-- Name: shipment_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY funding_info
    ADD CONSTRAINT shipment_exists FOREIGN KEY (shipment_id) REFERENCES shipment(shipment_id) ON DELETE RESTRICT;


--
-- TOC entry 134 (OID 1010987)
-- Name: funding_source_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY funding_info
    ADD CONSTRAINT funding_source_exists FOREIGN KEY (funding_source_id) REFERENCES funding_source(funding_source_id) ON DELETE RESTRICT;


--
-- TOC entry 124 (OID 1010991)
-- Name: si_tech_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipping_info
    ADD CONSTRAINT si_tech_exists FOREIGN KEY (technician_id) REFERENCES technician(technician_id) ON DELETE RESTRICT;


--
-- TOC entry 125 (OID 1010995)
-- Name: si_method_exists; Type: FK CONSTRAINT; Schema: public; Owner: zope3
--

ALTER TABLE ONLY shipping_info
    ADD CONSTRAINT si_method_exists FOREIGN KEY (temp_method_id) REFERENCES temp_method(temp_method_id) ON DELETE RESTRICT;



--
-- TOC entry 3 (OID 23533)
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: zope3
--

COMMENT ON SCHEMA public IS 'Standard public schema';


