# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: technician.py 749 2005-06-28 22:21:49Z sidnei $
"""

__metaclass__ = type

from datetime import date
from sqlobject import *
from sqlos import SQLOS
from zope.interface import implements
from zope.app import zapi

from sip.interfaces.technician import ITechnician
from sip.descriptors import FakePropertyDescriptor

class Technician(SQLOS):

    implements(ITechnician)

    _idName='technician_id'
    _columns = [
        StringCol('username', length=255, notNull=1),
        StringCol('fullname', length=255, notNull=0),
        DateCol('start_date', notNull=1, default=date.today),
        DateCol('end_date', notNull=0, default=None),
        StringCol('commit_message', notNull=1),
        ]

    name = FakePropertyDescriptor('name', 'username')
