# Copyright (c) 2004 by RUNYAGA, LLC.
# http://www.runyaga.com/

"""
$Id: units.py 749 2005-06-28 22:21:49Z sidnei $
"""

__metaclass__ = type

from datetime import date
from sqlobject import *
from sqlos import SQLOS
from zope.interface import implements
from zope.security.checker import NamesChecker
from zope.app import zapi

from sip.descriptors import FakePropertyDescriptor
from sip.interfaces.units import IConcentrationUnit, \
     IWeightUnit, IVolumeUnit

class BaseUnit:
    """ Remember Archetypes? :) """

    name = FakePropertyDescriptor('name', 'label')

class ConcentrationUnit(BaseUnit, SQLOS):

    implements(IConcentrationUnit)

    _idName = 'concentration_unit_id'
    _table = 'concentration_unit'

    _columns = [
        StringCol('label', length=255, notNull=1),
        StringCol('description', length=255, notNull=1, default=''),
        DecimalCol('exponent', size=24, precision=18, notNull=1, default=1),
        DateCol('start_date', notNull=1, default=date.today),
        DateCol('end_date', notNull=0, default=None),
        StringCol('commit_message', notNull=1),
        ]


class WeightUnit(BaseUnit, SQLOS):

    implements(IWeightUnit)

    _idName = 'weight_unit_id'
    _table = 'weight_unit'

    _columns = [
        StringCol('label', length=255, notNull=1),
        StringCol('description', length=255, notNull=1, default=''),
        DecimalCol('exponent', size=24, precision=18, notNull=1, default=1),
        DateCol('start_date', notNull=1,default=date.today),
        DateCol('end_date', notNull=0,default=None),
        StringCol('commit_message', notNull=1),
        ]


class VolumeUnit(BaseUnit, SQLOS):

    implements(IVolumeUnit)

    _idName = 'volume_unit_id'
    _table = 'volume_unit'

    _columns = [
        StringCol('label', length=255, notNull=1),
        StringCol('description', length=255, notNull=1, default=''),
        DecimalCol('exponent', size=24, precision=18, notNull=1, default=1),
        DateCol('start_date', notNull=1,default=date.today),
        DateCol('end_date', notNull=0,default=None),
        StringCol('commit_message', notNull=1),
        ]
