##############################################################################
#
# Copyright (c) 2004 Enfold Systems LLC. All rights reserved.
#
# This software is distributed under the terms of the Zope Public
# License (ZPL) v2.1. See COPYING.txt for more information.
#
##############################################################################
"""
$Id: adapter.py 5212 2004-06-21 18:09:05Z philikon $
"""
from zope.interface import Interface
from zope.schema import Choice
from zope.app.i18n import ZopeMessageIDFactory as _
from zope.app.container.constraints import ItemTypePrecondition
from zope.app.annotation.interfaces import IAttributeAnnotatable
from zope.app.container.interfaces import IAdding
from zope.app.container.interfaces import IContainerNamesContainer
from zope.app.container.interfaces import IReadContainer, IContainer

from sqlos.interfaces import ISQLObject

class ISQLObjectReadContainer(IReadContainer, IAttributeAnnotatable):
    """ An SQLObject Container """

class ISQLObjectContainer(IContainer, IContainerNamesContainer,
                          IAttributeAnnotatable):
    """ An SQLObject Container """

    def __setitem__(name, obj):
        """Add a new object"""

    __setitem__.precondition = ItemTypePrecondition()


class ISQLObjectAdding(IAdding):
    """A marker interface"""
