##############################################################################
#
# Copyright (c) 2004 Enfold Systems LLC. All rights reserved.
#
# This software is distributed under the terms of the Zope Public
# License (ZPL) v2.1. See COPYING.txt for more information.
#
##############################################################################
"""
$Id: __init__.py 5216 2004-06-21 18:33:07Z dreamcatcher $
"""

from zope.interface import Interface
from zope.configuration.fields import GlobalObject, MessageID
from zope.schema import TextLine

class IConnectionName(Interface):

    name = TextLine(
        title=u"Connection Name",
        required=True
        )

class IFactoryDirective(Interface):
    """
    Define a factory
    """

    component = GlobalObject(
        title=u"Component to be used",
        required=True
        )

    id = TextLine(
        title=u"ID",
        required=False
        )

    title = MessageID(
        title=u"Title",
        description=u"""
        text suitable for use in the 'add content' menu of a
        management interface""",
        required=False
        )

    description = MessageID(
        title=u"Description",
        description=u"Longer narrative description of what this factory does",
        required=False
        )
