"""
$Id: test_verify.py 5212 2004-06-21 18:09:05Z philikon $
"""

from zope.interface import Interface, implements, classImplements
from zope.interface.verify import verifyClass, verifyObject
from zope.interface.exceptions import DoesNotImplement, BrokenImplementation
from zope.interface.exceptions import BrokenMethodImplementation
from sqlobject.dbconnection import DBConnection, DBAPI
from sqlobject import _mysql, _postgres, _sybase
from sqlobject.main import SQLObject
from sqlos.interfaces import IDBConnection, \
     IDBAPI, ISQLConnection, ISQLObject

import unittest

class Test(unittest.TestCase):

    def testSQLObject(self):
        self.failUnless(verifyClass(ISQLObject, SQLObject))

    def testDBConnection(self):
        self.failUnless(verifyClass(IDBConnection, DBConnection ))

    def testDBAPI(self):
        self.failUnless(verifyClass(IDBAPI, DBAPI))

    def testMySQLConnection(self):
        self.failUnless(verifyClass(ISQLConnection, _mysql.builder()))

    def testPostgresConnection(self):
        self.failUnless(verifyClass(ISQLConnection, _postgres.builder()))

    def testSybaseConnection(self):
        self.failUnless(verifyClass(ISQLConnection, _sybase.builder()))

def test_suite():
    loader=unittest.TestLoader()
    return loader.loadTestsFromTestCase(Test)

if __name__=='__main__':
    unittest.TextTestRunner().run(test_suite())
